/*
 * PhotoDateWin - zapsanie EXIF informci o dtume odfotenia do sborov
 * premenovanch aplikciou PhotoDateJava.
 * Copyright (C) 2008 Mat Sulr
 *
 * You can run this software, redistribute it and/or modify its source code.
 * Commercial use is prohibited (because of the limitation given by the
 * program used to create this application).
 *
 * This software is distributed WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * If you are unsure about legal details, see C++ Builder 6 Personal License
 * Terms by Borland Software Corporation.
 */

//---------------------------------------------------------------------------
#include <mem.h>
#include <process.h>
#include <dir.h>
#include <vcl.h>
#include <IniFiles.hpp>
#pragma hdrstop
#include "main.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
#pragma resource "xp.res"
TfrmHlavny *frmHlavny;
TIniFile *ini; // subor s nastaveniami
bool zastav = false; // bolo stlacene tlacidlo Zastavit?
//---------------------------------------------------------------------------
__fastcall TfrmHlavny::TfrmHlavny(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------

/* rekurzivne prechadza priecinky a spusta program na zapisanie EXIF informacii */
void prejdi(String adresar) {
    if (!chdir(adresar.c_str()) && !zastav) {
    // ak bolo mozne zmenit priecinok a nebolo stlacene tlacidlo Zastavit
        TSearchRec zaznam;
        int hotovo;
        String meno, datum, prikaz;

        Application->ProcessMessages();

        // vyhladanie priecinkov
        hotovo = FindFirst("*", faDirectory, zaznam);
        while (!hotovo) {
            meno = zaznam.Name;
            if ((meno != ".") && (meno != "..") && DirectoryExists(meno))
                prejdi(meno);
            hotovo = FindNext(zaznam);
        }
        FindClose(zaznam);

        // vyhladanie fotografii
        bool adresar_log = false; // bol uz priecinok zapisany do logu?
        hotovo = FindFirst("'??-??-?? ??.??.??*.jpg", faAnyFile, zaznam);
        while (!(hotovo || zastav)) {
            meno = zaznam.Name;
            int rok, mesiac, den, hodina, minuta, sekunda;
            rok = StrToIntDef(meno.SubString(2, 2), 100);
            mesiac = StrToIntDef(meno.SubString(5, 2), 100);
            den = StrToIntDef(meno.SubString(8, 2), 100);
            hodina = StrToIntDef(meno.SubString(11, 2), 100);
            minuta = StrToIntDef(meno.SubString(14, 2), 100);
            sekunda = StrToIntDef(meno.SubString(17, 2), 100);

            // urcenie spravnosti formatu datumu
            bool spravny_format = rok >= 0 && rok <=99
             && mesiac >= 1 && mesiac <= 12 && den >= 1 && den <= 31
             && hodina >= 0 && hodina <= 23 && minuta >= 0 && minuta <= 59
             && sekunda >= 0 && sekunda <= 59;

            // ak meno znaci subor (nie priecinok) a ma format datumu
            if (!DirectoryExists(meno) && spravny_format) {
                // zapis nazvu priecinka do logu
                if (!adresar_log) {
                    String riadok
                     = IncludeTrailingPathDelimiter(GetCurrentDir());
                    frmHlavny->memPriebeh->Lines->Add(riadok);
                    adresar_log = true;
                }

                // datum pre EXIF
                datum = "20" + meno.SubString(2, 2) + ":" + meno.SubString(5, 2)
                 + ":" + meno.SubString(8, 2) + " " + meno.SubString(11, 2)
                 + ":" + meno.SubString(14, 2) + ":" + meno.SubString(17, 2);

                // prikaz, ktory sa spusti z aktualneho priecinka
                prikaz = "\"" + ExtractFilePath(Application->ExeName)
                 + "exiv2.exe\""
                 + " -k -M\"set Exif.Photo.DateTimeOriginal " + datum + "\""
                 + " -M\"set Exif.Photo.DateTimeDigitized " + datum + "\""
                 + " \"" + meno + "\"";

                // spustenie programu EXIV2 + zistenie navratovej hodnoty procesu
                TStartupInfo start;
                TProcessInformation proc;
                unsigned long stav;

                memset(&start, 0, sizeof(start));
                start.cb = sizeof(start);
                start.dwFlags = STARTF_USESHOWWINDOW;
                start.wShowWindow = SW_HIDE;
                CreateProcess(NULL, prikaz.c_str(), NULL, NULL,
                 false, 0, NULL, NULL, &start, &proc);
                WaitForSingleObject(proc.hProcess, INFINITE);
                GetExitCodeProcess(proc.hProcess, &stav);

                // zapis do logu
                String riadok = "\t" + meno;
                if (stav) // ak proces nevratil hodnotu 0
                    riadok += "\t - Error #" + String(stav);
                frmHlavny->memPriebeh->Lines->Add(riadok);
            }

            Application->ProcessMessages();
            hotovo = FindNext(zaznam);
        }
        FindClose(zaznam);

        ChDir("..");
    }
}
//---------------------------------------------------------------------------

/* nastavi vlastnost Enabled komponentov */
void povol_komponenty(bool povol)
{
    frmHlavny->rbEn->Enabled = povol;
    frmHlavny->rbSk->Enabled = povol;
    frmHlavny->dcbDisk->Enabled = povol;
    frmHlavny->dlbPriecinok->Enabled = povol;
    frmHlavny->btnStart->Enabled = povol;
}

void __fastcall TfrmHlavny::btnStartClick(TObject *Sender)
{
    memPriebeh->Lines->Clear();
    povol_komponenty(false);
    zastav = false;
    prejdi(dlbPriecinok->Directory);
    povol_komponenty(true);
}
//---------------------------------------------------------------------------

void __fastcall TfrmHlavny::FormCreate(TObject *Sender)
{
    ini = new TIniFile(ExtractFileDir(Application->ExeName) + "\\settings.ini");

    // jazyk
    if (ini->ReadInteger("Hlavne", "Jazyk", 0) == 1)
        rbSkClick(Sender);
    else
        rbEnClick(Sender);

    // priecinok
    String priecinok = ini->ReadString("Hlavne", "Priecinok", "C:\\");
    if (DirectoryExists(priecinok))
        dlbPriecinok->Directory = priecinok;
    dcbDisk->Drive = dlbPriecinok->Drive;
}
//---------------------------------------------------------------------------

void __fastcall TfrmHlavny::FormClose(TObject *Sender,
      TCloseAction &Action)
{
    ini->WriteString("Hlavne", "Priecinok", dlbPriecinok->Directory);
    delete ini;
}
//---------------------------------------------------------------------------

void __fastcall TfrmHlavny::rbEnClick(TObject *Sender)
{
    lblPopis->Caption = "PhotoDateWin writes the 'Date Taken' EXIF metadata to\
 JPEG photos. It uses the file name format produced by PhotoDateJava.";
    lblVarovanie->Caption = "2. Back up all important data.";
    lblPriecinok->Caption = "3. Select a directory where the photos are\
 located. Files in subdirectories will be overwritten, too.";
    btnStart->Caption = "4. Start writing";
    lblPriebeh->Caption = "5. Progress:";
    btnZastav->Caption = "Stop";

    rbEn->Checked = true;
    ini->WriteInteger("Hlavne", "Jazyk", 0);
}
//---------------------------------------------------------------------------

void __fastcall TfrmHlavny::rbSkClick(TObject *Sender)
{
    lblPopis->Caption = "PhotoDateWin zapisuje EXIF informciu o dtume\
 odfotenia snmky do JPEG fotografi. Pouva formt nzvu sboru vytvoren\
 aplikciou PhotoDateJava (http://sulo.stary-gympel.sk/photodatejava/).";
    lblVarovanie->Caption = "2. Zlohujte vetky dleit dta.";
    lblPriecinok->Caption = "3. Vyberte prieinok, kde sa nachdzaj\
 fotografie. Prepsan bud aj sbory v podprieinokch.";
    btnStart->Caption = "4. Zaa zapisovanie";
    lblPriebeh->Caption = "5. Priebeh:";
    btnZastav->Caption = "Zastavi";

    rbSk->Checked = true;
    ini->WriteInteger("Hlavne", "Jazyk", 1);
}
//---------------------------------------------------------------------------


void __fastcall TfrmHlavny::btnZastavClick(TObject *Sender)
{
    zastav = true;
}
//---------------------------------------------------------------------------

